#include <bits/stdc++.h>
using namespace std;
int main(int argc, char** argv) {
	int t,d;
	cin>>t;
	int mat[t][2];
	int konacno[t];
	for(int i=0; i<t; i++)
	{
		cin>>mat[i][0]; 
		cin>>mat[i][1]; 
		int x=mat[i][0];
		int y=mat[i][1];
		int niz[x]; 
		int dalijea=0;
		for(int j=0;j<x;j++)
		{
			cin>>niz[j];
		}
		sort(niz,niz+x);
		 d=niz[1]-niz[0];
		for(int j=1;j<x-1;j++)
		{
			if(d>niz[j+1]-niz[j]){
				if(d%(niz[j+1]-niz[j-1])!=0) dalijea=1;
			 	d=niz[j+1]-niz[j]; 
			 	
				}	
			else {
				if((niz[j+1]-niz[j-1])%d!=0) dalijea=1;
			}
			
			
		}
		int niz1[y];
		for(int k=0;k<y;k++)
		{
			cin>>niz1[k];
		}
		for(int s=0;s<y;s++)
		{
			if(dalijea==1) {
			konacno[i]=0;
			break;
		}
			if((niz1[s]-niz[0])%d!=0){
			 konacno[i]=1;
			 break;}
			else {
			konacno[i]=0;
			break;
		}
		}
	
	}
for(int i=0;i<t;i++)
	{
		cout<<konacno[i];
		cout<<endl;	
	}	
	return 0;
}